# Benchmarks

** TODO: à mettre à jour**

https://gitlab.gpf-tech.ign.fr/oslandia/pg_featureserv_test_tools.git

## Docker

* Build image :

```bash
docker build -t pgfs -f ci/benchmarks/Dockerfile .
```

Arguments :
`--build-arg BENCHMARKS_REF=true|false` permet de caluler les references des benchamarks.

Par defaut,

```bash
  CRUNCHYDATA_REPO="https://github.com/CrunchyData/pg_featureserv.git"
  CRUNCHYDATA_BRANCH="master"
  CRUNCHYDATA_PATCH_DIR="benchmarks"
  CRUNCHYDATA_PATCH_NAME="github-crunchydata-07990f9.patch"
```

* Run container :

```bash
docker run -it --rm \
       -v $(pwd)/reports:/usr/src/app/reports \
       --add-host="host.docker.internal:host-gateway" \
       --network="host" \
       --name my-pgfs pgfs
```

Exemple :

```bash
docker run -it --rm -v $(pwd)/reports:/usr/src/app/reports --add-host="host.docker.internal:host-gateway" --network="host" --name my-pgfs pgfs
```

Arguments :

```text
  --build-arg http_proxy=...
  --build-arg DATABASE_URL=...
  --build-arg PGFS_CACHE_REDIS_URL=...
  --build-arg PGFS_CACHE_REDIS_PASSWORD=...
```

ou utilisation de `docker-compose`

## Benchmarks

### implementation

* getCollections :

`GET /collections/mock_a`

* getCollectionItems :

```text
GET /collections/mock_a/items
GET /collections/mock_b/items
GET /collections/mock_c/items
```

* getCollectionItem :

```text
GET /collections/mock_a/items/1
GET /collections/mock_a/items/1 avec passage de l'ETag
```

### resultats

...

## Proxy

> Comprendre et utiliser un proxy dans docker, maven, npm...

* https://www.baeldung.com/ops/docker-setting-proxy
* https://docs.docker.com/config/daemon/systemd/#httphttps-proxy

Pour la modification du proxy settings dans docker, il existe plusieurs solutions.

1. settings systeme

    ```bash
    # desactiver :
    sudo sed -i '2 s/.*/Environment=/' /etc/systemd/system/docker.service.d/http-proxy.conf
    sudo sed -i '2 s/.*/Environment=/' /etc/systemd/system/docker.service.d/https-proxy.conf
    sudo systemctl daemon-reload && sudo systemctl restart docker
    systemctl show --property=Environment docker
    # activer :
    sudo sed -i '2 s/.*/Environment="HTTP_PROXY=http:\/\/proxy.ign.fr:3128\/"/' /etc/systemd/system/docker.service.d/http-proxy.conf
    sudo sed -i '2 s/.*/Environment="HTTPS_PROXY=http:\/\/proxy.ign.fr:3128\/"/' /etc/systemd/system/docker.service.d/https-proxy.conf
    sudo systemctl daemon-reload && sudo systemctl restart docker
    systemctl show --property=Environment docker
    ```

2. settings local

   since docker 17.07 you can simply configure the docker client proxy.
    (cf. https://docs.docker.com/network/proxy/#configure-the-docker-client)
    your `~/.docker/config.json` will be like :
    ```json
    {
        "proxies": {
            "default":{
                "httpProxy": "http://proxy.ign.fr:3128/",
                "httpsProxy": "http://proxy.ign.fr:3128/"
            }
        }
    }
    ```

**WARNING**
> les variables d'env (https_proxy / http_proxy) du systeme hote sont prises en compte !

Quelques astuces sur le proxy dans les containers :

cf. http://www.alain-andre.fr/docker/ruby/2016/11/08/faire-communiquer-des-conteneurs-docker.html

```bash
$> docker container inspect <container>
(...)
Env : [
    HTTP_PROXY
    HTTPS_PROXY
    (...)
]
(...)
```

## Divers

### Build image :

```bash
docker build -t pgfs_bench -f benchmarks/Dockerfile .
```

Arguments :
* `--build-arg BENCHMARKS_REF=true|false`

### Run container :

```bash
docker run -it --rm \
       -v $(pwd)/reports:/usr/src/app/reports \
       --add-host="host.docker.internal:host-gateway" \
       --network="host" \
       --name my-pgfs_bench pgfs_bench
```

ex. par defaut  :

```bash
docker run -it --rm -v $(pwd)/reports:/usr/src/app/reports --add-host="host.docker.internal:host-gateway" --network="host" --name my-pgfs_bench pgfs_bench
```

