package db_bench

/*
 Copyright 2022 Crunchy Data Solutions, Inc.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
      http://www.apache.org/licenses/LICENSE-2.0
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

 Date     : Octobre 2022
 Authors  : Jean-philippe Bazonnais (jean-philippe dot bazonnais at ign dot fr)
*/

import (
	"os"
	"testing"

	"github.com/CrunchyData/pg_featureserv/internal/conf"
	"github.com/CrunchyData/pg_featureserv/internal/data"
	"github.com/CrunchyData/pg_featureserv/internal/service"
	util "github.com/CrunchyData/pg_featureserv/internal/utiltest"
	log "github.com/sirupsen/logrus"
)

var hTest util.HttpTesting
var tableNames = []string{"public.mock_a", "public.mock_b", "public.mock_c"}

func TestMain(m *testing.M) {
	log.SetLevel(log.WarnLevel) // avoid boring messages
	conf.InitConfig("", true)   // getting default configuration
	service.SetCatalogInstance(data.CatDBInstance())

	hTest = util.MakeHttpTesting("http://test", "/pg_featureserv", "../../assets", service.InitRouter("/pg_featureserv"))

	service.Initialize()
	os.Exit(m.Run())
}
